#include "LedControl.h" //Imports LedControl Library

//Cool 3D Printed Case https://www.thingiverse.com/thing:1832790/files

const int buzzer = 10; //buzzer to arduino pin 10

int x0 = 1; int y0 = 0; //Assignes Analogue pins 0 and 1 to Joystick B
int xval0 = 512; int yval0 = 512; // Variables for Joystick B
int ycol0; // Variable for position of paddle B
const int buttonB = 8; bool buttonBstate = false;

int x1 = 3; int y1 = 2; //Assignes Analogue pins 2 and 3 to Joystick A
int xval1 = 512; int yval1 = 512; // Variables for Joystick A
int ycol1; // Variable for position of paddle A
const int buttonA = 9; bool buttonAstate = false;

bool readysteady = false;

int scoreA = 0; int scoreB = 0; //Variables for player scores

bool crashA = false; bool crashB = false;

int playSpeed = 50; //Starting speed, decreases each sucsesful hit

LedControl matrix = LedControl(13,12,11,4);//(DIN,CLK,CS,Displays)

void(* resetFunc) (void) = 0;

//Function to turn on/off all displays at once.
void Shutdown(bool power) {
  matrix.shutdown(0, power);
  matrix.shutdown(1, power);
  matrix.shutdown(2, power);
  matrix.shutdown(3, power);
}

//Function to set the intensity off all displays at once.
void SetIntensity(unsigned int brightness) {
  matrix.setIntensity(0, brightness);
  matrix.setIntensity(1, brightness);
  matrix.setIntensity(2, brightness);
  matrix.setIntensity(3, brightness);
}

//Function to clear all 4 displays.
void ClearAll() {
  matrix.clearDisplay(0);
  matrix.clearDisplay(1);
  matrix.clearDisplay(2);
  matrix.clearDisplay(3);
}

void joystick() {
  yval0 = analogRead(y0);
  ycol0 = map(yval0,0,1050,0,7);
  yval1 = analogRead(y1);
  ycol1 = map(yval1,0,1050,0,7);
  matrix.setRow(3,6,B00000000);
  matrix.setLed(3,6,ycol0,true);
  matrix.setLed(3,6,(ycol0+1),true);
  matrix.setRow(0,1,B00000000);
  matrix.setLed(0,1,ycol1,true);
  matrix.setLed(0,1,(ycol1+1),true);
}

//Function for Leftward balls
void left(int row, int dtime) {
  joystick();
  matrix.setLed(2,1,row,true);
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  matrix.setLed(2,1,row,false);
  matrix.setLed(2,2,row,true);
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  matrix.setLed(2,2,row,false);
  matrix.setLed(2,3,row,true);
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  matrix.setLed(2,3,row,false);
  matrix.setLed(2,4,row,true);
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  matrix.setLed(2,4,row,false);
  matrix.setLed(2,5,row,true);
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  matrix.setLed(2,5,row,false);
  matrix.setLed(2,6,row,true);
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  matrix.setLed(2,6,row,false);
  matrix.setLed(2,7,row,true);
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  matrix.setLed(2,7,row,false);
  matrix.setLed(3,0,row,true);
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  matrix.setLed(3,0,row,false);
  matrix.setLed(3,1,row,true);
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  matrix.setLed(3,1,row,false);
  matrix.setLed(3,2,row,true);
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  matrix.setLed(3,2,row,false);
  matrix.setLed(3,3,row,true);
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  matrix.setLed(3,3,row,false);
  matrix.setLed(3,4,row,true);
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  matrix.setLed(3,4,row,false);
  matrix.setLed(3,5,row,true);
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  matrix.setRow(3,5,B00000000);
  int leftpaddle = ycol0;
  if(row == leftpaddle || row == leftpaddle+1){
    joystick();
    tone(buzzer,2400);
    matrix.setLed(3,5,row,true);
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    noTone(buzzer);
    delay(dtime/4);
    joystick();
    matrix.setLed(3,5,row,false);
    matrix.setLed(3,4,row,true);
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    matrix.setLed(3,4,row,false);
    matrix.setLed(3,3,row,true);
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    matrix.setLed(3,3,row,false);
    matrix.setLed(3,2,row,true);
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    matrix.setLed(3,2,row,false);
    matrix.setLed(3,1,row,true);
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    matrix.setLed(3,1,row,false);
    matrix.setLed(3,0,row,true);
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    matrix.setLed(3,0,row,false);
    matrix.setLed(2,7,row,true);
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    matrix.setLed(2,7,row,false);
    matrix.setLed(2,6,row,true);
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    matrix.setLed(2,6,row,false);
    matrix.setLed(2,5,row,true);
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    matrix.setLed(2,5,row,false);
    matrix.setLed(2,4,row,true);
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    matrix.setLed(2,4,row,false);
    matrix.setLed(2,3,row,true);
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    matrix.setLed(2,3,row,false);
    matrix.setLed(2,2,row,true);
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    matrix.setLed(2,2,row,false);
    matrix.setLed(2,1,row,true);
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    matrix.setRow(2,1,B00000000);
    joystick();
    scoreA = scoreA + 1;
    playSpeed = playSpeed - 2;
  }
  else {
    matrix.setLed(3,6,row,true);
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    matrix.setLed(3,6,row,false);
    matrix.setLed(3,7,row,true);
    tone(buzzer,2400);
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    noTone(buzzer);
    matrix.setLed(3,7,row,false);
    crashA = true;
  }
}

//Function for Rightward balls
void right(int row, int dtime) {
  joystick();
  matrix.setLed(1,6,row,true);
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  matrix.setLed(1,6,row,false);
  matrix.setLed(1,5,row,true);
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  matrix.setLed(1,5,row,false);
  matrix.setLed(1,4,row,true);
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  matrix.setLed(1,4,row,false);
  matrix.setLed(1,3,row,true);
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  matrix.setLed(1,3,row,false);
  matrix.setLed(1,2,row,true);
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  matrix.setLed(1,2,row,false);
  matrix.setLed(1,1,row,true);
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  matrix.setLed(1,1,row,false);
  matrix.setLed(1,0,row,true);
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  matrix.setLed(1,0,row,false);
  matrix.setLed(0,7,row,true);
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  matrix.setLed(0,7,row,false);
  matrix.setLed(0,6,row,true);
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  matrix.setLed(0,6,row,false);
  matrix.setLed(0,5,row,true);
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  matrix.setLed(0,5,row,false);
  matrix.setLed(0,4,row,true);
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  matrix.setLed(0,4,row,false);
  matrix.setLed(0,3,row,true);
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  matrix.setLed(0,3,row,false);
  matrix.setLed(0,2,row,true);
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  delay(dtime/4);
  joystick();
  matrix.setRow(0,2,B00000000);
  yval0 = analogRead(y0);
  ycol0 = map(yval0,0,1050,0,7);
  matrix.setRow(3,6,B00000000);
  matrix.setLed(3,6,ycol0,true);
  matrix.setLed(3,6,(ycol0+1),true);
  int rightpaddle = ycol1;
  if(row == rightpaddle || row == rightpaddle+1){
    joystick();
    tone(buzzer,2400);
    matrix.setLed(0,2,row,true);
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    noTone(buzzer);
    delay(dtime/4);
    joystick();
    matrix.setLed(0,2,row,false);
    matrix.setLed(0,3,row,true);
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    matrix.setLed(0,3,row,false);
    matrix.setLed(0,4,row,true);
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    matrix.setLed(0,4,row,false);
    matrix.setLed(0,5,row,true);
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    matrix.setLed(0,5,row,false);
    matrix.setLed(0,6,row,true);
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    matrix.setLed(0,6,row,false);
    matrix.setLed(0,7,row,true);
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    matrix.setLed(0,7,row,false);
    matrix.setLed(1,0,row,true);
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    matrix.setLed(1,0,row,false);
    matrix.setLed(1,1,row,true);
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    matrix.setLed(1,1,row,false);
    matrix.setLed(1,2,row,true);
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    matrix.setLed(1,2,row,false);
    matrix.setLed(1,3,row,true);
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    matrix.setLed(1,3,row,false);
    matrix.setLed(1,4,row,true);
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    matrix.setLed(1,4,row,false);
    matrix.setLed(1,5,row,true);
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    matrix.setLed(1,5,row,false);
    matrix.setLed(1,6,row,true);
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    matrix.setRow(1,6,B00000000);
    joystick();
    scoreB = scoreB + 1;
    playSpeed = playSpeed - 2;
  }
  else {
    matrix.setLed(0,1,row,true);
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    matrix.setLed(0,1,row,false);
    matrix.setLed(0,0,row,true);
    tone(buzzer,2400);
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    noTone(buzzer);
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    delay(dtime/4);
    joystick();
    matrix.setLed(0,0,row,false);
    crashB = true;
  }
}

void Smiley(int displayno) {
  byte smiley[8]={B00111100,B01000010,B10101001,B10000101,B10000101,B10101001,B01000010,B00111100}; //Smiley face pixles
  matrix.setRow(displayno,0,smiley[0]);
  matrix.setRow(displayno,1,smiley[1]);
  matrix.setRow(displayno,2,smiley[2]);
  matrix.setRow(displayno,3,smiley[3]);
  matrix.setRow(displayno,4,smiley[4]);
  matrix.setRow(displayno,5,smiley[5]);
  matrix.setRow(displayno,6,smiley[6]);
  matrix.setRow(displayno,7,smiley[7]);
}

void Cross(int displayno1) {
  byte crossx[8]={B10000001,B01000010,B00100100,B00011000,B00011000,B00100100,B01000010,B10000001}; //X xross pixles
  matrix.setRow(displayno1,0,crossx[0]);
  matrix.setRow(displayno1,1,crossx[1]);
  matrix.setRow(displayno1,2,crossx[2]);
  matrix.setRow(displayno1,3,crossx[3]);
  matrix.setRow(displayno1,4,crossx[4]);
  matrix.setRow(displayno1,5,crossx[5]);
  matrix.setRow(displayno1,6,crossx[6]);
  matrix.setRow(displayno1,7,crossx[7]);
}

void Tick(int displayno11) {
  byte tick[8]={B01000000,B00100000,B00010000,B00001000,B00000100,B00000010,B00000100,B00001000}; //X xross pixles
  matrix.setRow(displayno11,0,tick[0]);
  matrix.setRow(displayno11,1,tick[1]);
  matrix.setRow(displayno11,2,tick[2]);
  matrix.setRow(displayno11,3,tick[3]);
  matrix.setRow(displayno11,4,tick[4]);
  matrix.setRow(displayno11,5,tick[5]);
  matrix.setRow(displayno11,6,tick[6]);
  matrix.setRow(displayno11,7,tick[7]);
}

void Question(int displayno12) {
  byte question[8]={B01000000,B00000000,B00100000,B01000000,B01000101,B01001000,B00110000,B00000000}; //? xross pixles
  matrix.setRow(displayno12,0,question[0]);
  matrix.setRow(displayno12,1,question[1]);
  matrix.setRow(displayno12,2,question[2]);
  matrix.setRow(displayno12,3,question[3]);
  matrix.setRow(displayno12,4,question[4]);
  matrix.setRow(displayno12,5,question[5]);
  matrix.setRow(displayno12,6,question[6]);
  matrix.setRow(displayno12,7,question[7]);
}

void Zero(int displayno0) {
  byte xero[7]={B00000000,B00111110,B01010001,B01001001,B01000101,B00111110,B00000000}; //0 pixles
  matrix.setRow(displayno0,0,xero[0]);
  matrix.setRow(displayno0,1,xero[1]);
  matrix.setRow(displayno0,2,xero[2]);
  matrix.setRow(displayno0,3,xero[3]);
  matrix.setRow(displayno0,4,xero[4]);
  matrix.setRow(displayno0,5,xero[5]);
  matrix.setRow(displayno0,6,xero[6]);
  matrix.setRow(displayno0,7,xero[7]);
}

void One(int displayno2) {
  byte one[7]={B00000000,B00000000,B00000001,B01111111,B00100001,B00000000,B00000000}; //1 pixles
  matrix.setRow(displayno2,0,one[0]);
  matrix.setRow(displayno2,1,one[1]);
  matrix.setRow(displayno2,2,one[2]);
  matrix.setRow(displayno2,3,one[3]);
  matrix.setRow(displayno2,4,one[4]);
  matrix.setRow(displayno2,5,one[5]);
  matrix.setRow(displayno2,6,one[6]);
  matrix.setRow(displayno2,7,one[7]);
}

void Two(int displayno3) {
  byte two[7]={B00000000,B00110001,B01001001,B01000101,B01000011,B00100001,B00000000}; //2 pixles
  matrix.setRow(displayno3,0,two[0]);
  matrix.setRow(displayno3,1,two[1]);
  matrix.setRow(displayno3,2,two[2]);
  matrix.setRow(displayno3,3,two[3]);
  matrix.setRow(displayno3,4,two[4]);
  matrix.setRow(displayno3,5,two[5]);
  matrix.setRow(displayno3,6,two[6]);
  matrix.setRow(displayno3,7,two[7]);
}

void Three(int displayno4) {
  byte three[7]={B00000000,B00110110,B01001001,B01001001,B01001001,B01000001,B00000000}; //3 pixles
  matrix.setRow(displayno4,0,three[0]);
  matrix.setRow(displayno4,1,three[1]);
  matrix.setRow(displayno4,2,three[2]);
  matrix.setRow(displayno4,3,three[3]);
  matrix.setRow(displayno4,4,three[4]);
  matrix.setRow(displayno4,5,three[5]);
  matrix.setRow(displayno4,6,three[6]);
  matrix.setRow(displayno4,7,three[7]);
}

void Four(int displayno5) {
  byte four[7]={B00000000,B01111111,B00001000,B00001000,B00001000,B01111000,B00000000}; //4 pixles
  matrix.setRow(displayno5,0,four[0]);
  matrix.setRow(displayno5,1,four[1]);
  matrix.setRow(displayno5,2,four[2]);
  matrix.setRow(displayno5,3,four[3]);
  matrix.setRow(displayno5,4,four[4]);
  matrix.setRow(displayno5,5,four[5]);
  matrix.setRow(displayno5,6,four[6]);
  matrix.setRow(displayno5,7,four[7]);
}

void Five(int displayno6) {
  byte five[7]={B00000000,B01000110,B01001001,B01001001,B01001001,B01111001,B00000000}; //5 pixles
  matrix.setRow(displayno6,0,five[0]);
  matrix.setRow(displayno6,1,five[1]);
  matrix.setRow(displayno6,2,five[2]);
  matrix.setRow(displayno6,3,five[3]);
  matrix.setRow(displayno6,4,five[4]);
  matrix.setRow(displayno6,5,five[5]);
  matrix.setRow(displayno6,6,five[6]);
  matrix.setRow(displayno6,7,five[7]);
}

void Six(int displayno7) {
  byte six[7]={B00000000,B00000110,B01001001,B01001001,B01001001,B00111110,B00000000}; //6 pixles
  matrix.setRow(displayno7,0,six[0]);
  matrix.setRow(displayno7,1,six[1]);
  matrix.setRow(displayno7,2,six[2]);
  matrix.setRow(displayno7,3,six[3]);
  matrix.setRow(displayno7,4,six[4]);
  matrix.setRow(displayno7,5,six[5]);
  matrix.setRow(displayno7,6,six[6]);
  matrix.setRow(displayno7,7,six[7]);
}

void Severn(int displayno8) {
  byte severn[7]={B00000000,B01110000,B01001000,B01000111,B01000000,B01000000,B00000000}; //7 pixles
  matrix.setRow(displayno8,0,severn[0]);
  matrix.setRow(displayno8,1,severn[1]);
  matrix.setRow(displayno8,2,severn[2]);
  matrix.setRow(displayno8,3,severn[3]);
  matrix.setRow(displayno8,4,severn[4]);
  matrix.setRow(displayno8,5,severn[5]);
  matrix.setRow(displayno8,6,severn[6]);
  matrix.setRow(displayno8,7,severn[7]);
}

void Eight(int displayno9) {
  byte eight[7]={B00000000,B00110110,B01001001,B01001001,B01001001,B00110110,B00000000}; //8 pixles
  matrix.setRow(displayno9,0,eight[0]);
  matrix.setRow(displayno9,1,eight[1]);
  matrix.setRow(displayno9,2,eight[2]);
  matrix.setRow(displayno9,3,eight[3]);
  matrix.setRow(displayno9,4,eight[4]);
  matrix.setRow(displayno9,5,eight[5]);
  matrix.setRow(displayno9,6,eight[6]);
  matrix.setRow(displayno9,7,eight[7]);
}

void Nine(int displayno10) {
  byte nine[7]={B00000000,B00111110,B01001001,B01001001,B01001001,B00110010,B00000000}; //9 pixles
  matrix.setRow(displayno10,0,nine[0]);
  matrix.setRow(displayno10,1,nine[1]);
  matrix.setRow(displayno10,2,nine[2]);
  matrix.setRow(displayno10,3,nine[3]);
  matrix.setRow(displayno10,4,nine[4]);
  matrix.setRow(displayno10,5,nine[5]);
  matrix.setRow(displayno10,6,nine[6]);
  matrix.setRow(displayno10,7,nine[7]);
}

void score(){
  switch (scoreA) {
    case 0:
    Zero(2);
    break;
    case 1:
    One(2);
    break;
    case 2:
    Two(2);
    break;
    case 3:
    Three(2);
    break;
    case 4:
    Four(2);
    break;
    case 5:
    Five(2);
    break;
    case 6:
    Six(2);
    break;
    case 7:
    Severn(2);
    break;
    case 8:
    Eight(2);
    break;
    case 9:
    Nine(2);
    break;
  }
  switch (scoreB) {
    case 0:
    Zero(1);
    break;
    case 1:
    One(1);
    break;
    case 2:
    Two(1);
    break;
    case 3:
    Three(1);
    break;
    case 4:
    Four(1);
    break;
    case 5:
    Five(1);
    break;
    case 6:
    Six(1);
    break;
    case 7:
    Severn(1);
    break;
    case 8:
    Eight(1);
    break;
    case 9:
    Nine(1);
    break;
  }
  matrix.setRow(1,7,B00100100);
}

void Ready() {
  while ((buttonAstate == false) || (buttonAstate == false)) {
    buttonAstate = digitalRead(buttonA);
    buttonBstate = digitalRead(buttonB);
    if (buttonAstate == true) {
      Tick(3);
    }
    if (buttonBstate == true) {
      Tick(0);
    }
  }
  if ((buttonAstate == true) && (buttonAstate == true)) {
    readysteady = true;
  }
  delay(500);
}

void setup() {
  pinMode(buzzer, OUTPUT);
  pinMode(8, INPUT);
  pinMode(9, INPUT);
  Shutdown(false); //Sets the displays to ON
  SetIntensity(4); //Brightness (0-15) (custom function)
  ClearAll(); //Clears all displays (custom function)
  matrix.setRow(1,7,B11111111); //Middle 'net'
  matrix.setRow(2,0,B11111111); //Middle 'net'
  
}
  
void loop() {
  //if (readysteady == false) {
  //  Ready();
  //}
  joystick(); //Gets the Joystick Position (custom function)
  left(random(0,8),playSpeed); //Fires the ball to the left (custom function)
  if (crashA == true) {
    ClearAll();
    Smiley(0);//Smiley right, cross left
    Cross(3);
    matrix.setRow(2,7,B11111111);
    score();
    delay(5000);
    resetFunc();
  }
  else if (crashB == true) {
    ClearAll();
    Smiley(3); //smiley left, cross right
    Cross(0);
    matrix.setRow(2,7,B11111111);
    score();
    delay(5000);
    resetFunc();
  } 
  right(random(0,8),playSpeed); //Fires the ball to the right (custom function)
  if (crashA == true) {
    Smiley(0);//Smiley right, cross left
    Cross(3);
    score();
    delay(5000);
    resetFunc();
  }
  else if (crashB == true) {
    Smiley(3); //smiley left, cross right
    Cross(0);
    score();
    delay(5000);
    resetFunc();
  }
  else {
    if (scoreA == 9 || scoreB == 9){
      if (scoreA > scoreB){
        Smiley(3); //smiley left, cross right
        Cross(0);
      }
      else if (scoreB > scoreA) {
        Smiley(0);//Smiley right, cross left
        Cross(3);
      }
      else{
        Smiley(0);//smiley both sides
        Smiley(3);
      }
      score();
      delay(5000);
      resetFunc();
  } 
 }
}
